local Point = require("point").Point
local BasicTool = {}


function BasicTool:new()
  BasicTool.targetSize = Point:new(BLOCK_SIZE*2, BLOCK_SIZE*2)
  BasicTool.radius = BLOCK_SIZE * 10
  self.__index = self
  
  local instance = {
      shift = Point:new(0,0),
      position = Point:new(0,0),
      dt = 0
  }
  setmetatable(instance, self)
  return instance
end

function BasicTool:apply(things)
  for _, thing in ipairs(things) do
    if thing.isBlock and not thing.passable then  
      thing:setDurability(thing:getDurability()-100000*self.dt)
    end
  end
end

function BasicTool:setShift(shift)
  self.shift:set(shift:cappedLength(self.radius))
end





return BasicTool