local fileUtils = require("utils.fileutils")
local testPath = "test"

local function exceptThisFile(path)  
  return fileUtils.extract(path)~="test.lua"
end

local runTest

local function runTestsInDir(directoryPath)
  fileUtils.forChildPaths(directoryPath, runTest, exceptThisFile)
end

function runTest(testPath)
  if love.filesystem.isDirectory(testPath) then
    runTestsInDir(testPath)
  else
    love.filesystem.load(testPath)()
    print("test "..testPath.." OK")
  end
end


runTestsInDir(testPath)

