local ffi = require("ffi")
      
ffi.cdef[[
  typedef struct {
    char *fpos;
    void *base;
    unsigned short handle;
    short flags;
    short unget;
    unsigned long alloc;
    unsigned short buffincrement;
  } FILE;

  FILE *fopen(const char *filename, const char *mode);
  int fprintf(FILE *stream, const char *format, ...);
  int fclose(FILE *stream);
]]

local C = ffi.C



local inputChannel = love.thread.getChannel("saveFileChannelParams")    
local outputChannel = love.thread.getChannel("fileChannelResult")          

repeat
  local fileName, data, callBackIndex = unpack(inputChannel:demand())    
  
  local f = C.fopen(fileName, "w")
  C.fprintf(f, "%s",data)
  C.fclose(f)
  outputChannel:push({callBackIndex})                
until false